// Code generated by Community Administration CLI. DO NOT EDIT.

package model

import (
	"reflect"

	"github.com/invopop/jsonschema"
	"github.com/stoewer/go-strcase"
)

type TypeCommunityEvent string

const (
	COMMUNITY_INFO_CHANGED TypeCommunityEvent = "COMMUNITY_INFO_CHANGED"
	SUBSCRIPTION_FEE_SET   TypeCommunityEvent = "SUBSCRIPTION_FEE_SET"
)

type CommunityEventType struct {
	Type TypeCommunityEvent `json:"type" jsonschema:"enum=COMMUNITY_INFO_CHANGED,enum=SUBSCRIPTION_FEE_SET"`
}

func (e CommunityInfoChanged) isCommunityEvent() {}

func (e CommunityInfoChanged) GetBaseCommunityEvent() BaseCommunityEvent {
	return e.BaseCommunityEvent
}

func (e SubscriptionFeeSet) isCommunityEvent() {}

func (e SubscriptionFeeSet) GetBaseCommunityEvent() BaseCommunityEvent {
	return e.BaseCommunityEvent
}

func GetReflectedCommunityEventTypeStructSlice() (*[]*jsonschema.Schema, error) {
	reflector := new(jsonschema.Reflector)
	reflector.BaseSchemaID = "https://community-administration-cli.nl/schema"

	reflector.KeyNamer = strcase.LowerCamelCase

	if err := reflector.AddGoComments("gitlab.com/z.amir/community-administration-cli", "./"); err != nil {
		return nil, err
	}

	reflectedEvents := []*jsonschema.Schema{
		reflector.ReflectFromType(reflect.TypeOf(&CommunityInfoChanged{})),
		reflector.ReflectFromType(reflect.TypeOf(&SubscriptionFeeSet{})),
	}

	return &reflectedEvents, nil
}
